// This file is part of the PiDuce project (http://www.cs.unibo.it/Piduce/)
// developed at the Department of Computer Science of Bologna.
// Authors: Samuele Carpineti, Cosimo Laneve, Luca Padovani
//
// See Copyright for the status of this software.

using System;

namespace PiDuce.Common
{
	public class Pair<S, T>
	{
		private readonly S first;
		private readonly T second;

		public S First { get { return first; } }
		public T Second { get { return second; } }

		public Pair(S first, T second)
		{
			this.first = first;
			this.second = second;
		}

		public override bool Equals(Object obj)
		{
			if (obj is Pair<S, T>) {
				Pair<S, T> pair = (Pair<S, T>) obj;
				return first.Equals(pair.first) && second.Equals(pair.second);
			} else
				return false;
		}

		public override int GetHashCode()
		{ return first.GetHashCode() ^ second.GetHashCode(); }

		public override string ToString()
		{ return first.ToString() + ", " + second.ToString(); }
	}
}

